const NewByteReceiveRate = '0_userdata.0.FritzBox.NewByteReceiveRate';
const NewByteSendRate = '0_userdata.0.FritzBox.NewByteSendRate';
const L1DownMaxRate = '0_userdata.0.FritzBox.Layer1DownstreamMaxBitRate';
const L1UpMaxRate = '0_userdata.0.FritzBox.Layer1UpstreamMaxBitRate';
const ReceiveR = '0_userdata.0.FritzBox.Charts.Receive';
const SendR = '0_userdata.0.FritzBox.Charts.Send';

createState(NewByteReceiveRate, 0, {type: 'number', read: true, write: true});
createState(NewByteSendRate, 0, {type: 'number', read: true, write: true});
createState(L1DownMaxRate, 0, {type: 'number', read: true, write: true});
createState(L1UpMaxRate, 0, {type: 'number', read: true, write: true});
createState(ReceiveR, 0, {type: 'number', unit: 'MBit/s', read: true, write: true});
createState(SendR, 0, {type: 'number', unit: 'MBit/s', read: true, write: true});

schedule('*/6 * * * * *', function Aktualisierung() {
    setState('tr-064.0.states.command', '{"service": "urn:dslforum-org:service:WANCommonInterfaceConfig:1","action": "X_AVM-DE_GetOnlineMonitor","params": {"NewSyncGroupIndex": 0}}');
    var value=getState('tr-064.0.states.commandResult').val;

    if (value.indexOf('NewTotalNumber') == 2) {
        var obj = JSON.parse(value);
        var DownStream = obj.Newds_current_bps;
        var UpStream = obj.Newus_current_bps;
        var ds = DownStream.split(",");
        var us = UpStream.split(",");
        var wds    =  ds[0];
        var wus    =  us[0];

        setState(NewByteReceiveRate, wds*1, true);
        setState(NewByteSendRate, wus*1, true);

        setState(ReceiveR, Math.round((wds*0.000008)*100)/100, true);
        setState(SendR, Math.round((wus*0.000008)*100)/100, true);

        setState(L1DownMaxRate, obj.Newmax_ds*8, true);
        setState(L1UpMaxRate, obj.Newmax_us*8, true);
    }
});