const System_Aktiv = '0_userdata.0.Ping.Rechenkraft';
const RAM_Total = '0_userdata.0.SNMP.192_168_10_3.RAM_Total';
const RAM_Frei = '0_userdata.0.SNMP.192_168_10_3.RAM_Frei';
const SWAP_Total = '0_userdata.0.SNMP.192_168_10_3.SWAP_Gesamt';
const SWAP_Frei = '0_userdata.0.SNMP.192_168_10_3.SWAP_Verfügbar';
const R3Temperatur = '0_userdata.0.SNMP.192_168_10_3.Temperatur';
const Net_IN = '0_userdata.0.SNMP.192_168_10_3.Net_In';
const Net_OUT = '0_userdata.0.SNMP.192_168_10_3.Net_Out';

var vSystem_Aktiv = getState(System_Aktiv).val;
var vRAM_Total = getState(RAM_Total).val;
var vRAM_Frei = getState(RAM_Frei).val;
var vSWAP_Total = getState(SWAP_Total).val;
var vSWAP_Frei = getState(SWAP_Frei).val;
var vR3Temperatur = getState(R3Temperatur).val;
var vNet_IN = getState(Net_IN).val;
var vNet_OUT = getState(Net_OUT).val;

const RAM_Genutzt = '0_userdata.0.Rechenkraft.RAM_Genutzt';
const SWAP_Genutzt = '0_userdata.0.Rechenkraft.SWAP_Genutzt';
const CPU_Temperatur = '0_userdata.0.Rechenkraft.Temperatur';

const In_Summe = '0_userdata.0.Rechenkraft.Network.In_Summe';
const Out_Summe = '0_userdata.0.Rechenkraft.Network.Out_Summe';
const In_Speed = '0_userdata.0.Rechenkraft.Network.In_Speed';
const Out_Speed = '0_userdata.0.Rechenkraft.Network.Out_Speed';

createState(SWAP_Genutzt, 0, {type: 'number', unit: 'KB', read: true, write: true});
createState(RAM_Genutzt, 0, {type: 'number', unit: 'KB', read: true, write: true});
createState(CPU_Temperatur, 0, {type: 'number', unit: '°C', read: true, write: true});

createState(In_Summe, 0, {type: 'string', unit: 'MB', read: true, write: true});
createState(Out_Summe, 0, {type: 'string', unit: 'MB', read: true, write: true});
createState(In_Speed, 0, {type: 'string', unit: 'MBit/s', read: true, write: true});
createState(Out_Speed, 0, {type: 'string', unit: 'MBit/s', read: true, write: true});

var IN_NEW = 0;
var OUT_NEW = 0;
var IN_OLD = 0;
var OUT_OLD = 0;
var IN_DIFF = 0;
var OUT_DIFF = 0;
var IN_SUM = 0;
var OUT_SUM = 0;

function round(num) {
    var m = Number((Math.abs(num) * 100).toPrecision(15));
    var t = Math.round(m) / 100 * Math.sign(num);
    return t.toFixed(2).replace('.', ',').replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1.');
}

function Netzwerk() {
    vSystem_Aktiv = getState(System_Aktiv).val;
    if(vSystem_Aktiv === true) {
        IN_OLD=IN_NEW;
        OUT_OLD=OUT_NEW;
        IN_NEW=getState(Net_IN).val*1;
        OUT_NEW=getState(Net_OUT).val*1;

        IN_DIFF=IN_NEW-IN_OLD;
        if (IN_DIFF < 0) {
            IN_DIFF=(4294967295-IN_OLD)+IN_NEW;
        }
        IN_SUM=IN_SUM+IN_DIFF;

        OUT_DIFF=OUT_NEW-OUT_OLD;
        if (OUT_DIFF < 0) {
            OUT_DIFF=(4294967295-OUT_OLD)+OUT_NEW;
        }
        OUT_SUM=OUT_SUM+OUT_DIFF;
        setState(In_Summe, round(IN_SUM/1024/1024), true);
        setState(Out_Summe, round(OUT_SUM/1024/1024), true);
        setState(In_Speed, round((IN_DIFF/1024/1024)*8/10), true);
        setState(Out_Speed, round((OUT_DIFF/1024/1024)*8/10), true);
    } else {
        IN_NEW = 0;
        OUT_NEW = 0;
        IN_OLD = 0;
        OUT_OLD = 0;
        IN_DIFF = 0;
        OUT_DIFF = 0;
        IN_SUM = 0;
        OUT_SUM = 0;
        vNet_IN = 0;
        vNet_OUT = 0;
        setState(In_Summe, '0', true);
        setState(Out_Summe, '0', true);
        setState(In_Speed, '0,00', true);
        setState(Out_Speed, '0,00', true);
        setState('0_userdata.0.SNMP.192_168_10_3.Net_In', 0, true);
        setState('0_userdata.0.SNMP.192_168_10_3.Net_Out', 0, true);
    }
}

on(R3Temperatur, function(dp) {
    vR3Temperatur = dp.state.val;
    var cTemp=vR3Temperatur*0.001;
    setState(CPU_Temperatur, Math.round(cTemp*100)/100, true);
});

on(SWAP_Frei, function(dp) {
    vSWAP_Frei = dp.state.val;
    setState(SWAP_Genutzt, vSWAP_Total*1 - vSWAP_Frei*1, true);
});

on(RAM_Frei, function(dp) {
    vRAM_Frei = dp.state.val;
    setState(RAM_Genutzt, vRAM_Total*1 - vRAM_Frei*1, true);
});

schedule('*/10 * * * * *', function RechenkraftNet() {
    Netzwerk();
});