const HDD_Total = 'system.host.ubuntu-server.diskSize';
const HDD_Free = 'system.host.ubuntu-server.diskFree';
const Net_IN = '0_userdata.0.SNMP.127_0_0_1.Net_In';
const Net_OUT = '0_userdata.0.SNMP.127_0_0_1.Net_Out';
const Temperatur = '0_userdata.0.SNMP.127_0_0_1.Temperatur';
const TemperaturC0 = '0_userdata.0.SNMP.127_0_0_1.Core0';
const RAM_Total = '0_userdata.0.SNMP.127_0_0_1.RAM_Total';
const RAM_Frei = '0_userdata.0.SNMP.127_0_0_1.RAM_Frei';
const SWAP_Total = '0_userdata.0.SNMP.127_0_0_1.SWAP_Gesamt';
const SWAP_Frei = '0_userdata.0.SNMP.127_0_0_1.SWAP_Verfügbar';

const HDD_Used = '0_userdata.0.RPI.HDD_Used';
const In_Summe = '0_userdata.0.RPI.Network.In_Summe';
const Out_Summe = '0_userdata.0.RPI.Network.Out_Summe';
const In_Speed = '0_userdata.0.RPI.Network.In_Speed';
const Out_Speed = '0_userdata.0.RPI.Network.Out_Speed';
const CPU_Temperatur = '0_userdata.0.RPI.Temperatur';
const CPU_Temperatur_0 = '0_userdata.0.RPI.Temperatur_Core0';
const RAM_Genutzt = '0_userdata.0.RPI.RAM_Genutzt';
const SWAP_Genutzt = '0_userdata.0.RPI.SWAP_Genutzt';

var vHDD_Total = getState(HDD_Total).val;
var vHDD_Free = getState(HDD_Free).val;
var vNet_IN = getState(Net_IN).val;
var vNet_OUT = getState(Net_OUT).val;
var vTemperatur = getState(Temperatur).val;
var vTemperaturC0 = getState(TemperaturC0).val;
var vRAM_Total = getState(RAM_Total).val;
var vRAM_Frei = getState(RAM_Frei).val;
var vSWAP_Total = getState(SWAP_Total).val;
var vSWAP_Frei = getState(SWAP_Frei).val;

createState(HDD_Used, 0, {type: 'number', unit: 'MB', read: true, write: true});
createState(In_Summe, 0, {type: 'string', unit: 'MB', read: true, write: true});
createState(Out_Summe, 0, {type: 'string', unit: 'MB', read: true, write: true});
createState(In_Speed, 0, {type: 'string', unit: 'MBit/s', read: true, write: true});
createState(Out_Speed, 0, {type: 'string', unit: 'MBit/s', read: true, write: true});
createState(CPU_Temperatur, 0, {type: 'number', unit: '°C', read: true, write: true});
createState(CPU_Temperatur_0, 0, {type: 'number', unit: '°C', read: true, write: true});
createState(RAM_Genutzt, 0, {type: 'number', unit: 'KB', read: true, write: true});
createState(SWAP_Genutzt, 0, {type: 'number', unit: 'KB', read: true, write: true});


var IN_NEW = 0;
var OUT_NEW = 0;
var IN_OLD = 0;
var OUT_OLD = 0;
var IN_DIFF = 0;
var OUT_DIFF = 0;
var IN_SUM = 0;
var OUT_SUM = 0;

function round(num) {
    var m = Number((Math.abs(num) * 100).toPrecision(15));
    var t = Math.round(m) / 100 * Math.sign(num);
    return t.toFixed(2).replace('.', ',').replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1.');
}

function Netzwerk() {
    IN_OLD=IN_NEW;
    OUT_OLD=OUT_NEW;
    IN_NEW=getState(Net_IN).val*1;
    OUT_NEW=getState(Net_OUT).val*1;

    IN_DIFF=IN_NEW-IN_OLD;
    if (IN_DIFF < 0) {
        IN_DIFF=(4294967295-IN_OLD)+IN_NEW;
    }
    IN_SUM=IN_SUM+IN_DIFF;

    OUT_DIFF=OUT_NEW-OUT_OLD;
    if (OUT_DIFF < 0) {
        OUT_DIFF=(4294967295-OUT_OLD)+OUT_NEW;
    }
    OUT_SUM=OUT_SUM+OUT_DIFF;
    setState(In_Summe, round(IN_SUM/1024/1024), true);
    setState(Out_Summe, round(OUT_SUM/1024/1024), true);
    setState(In_Speed, round((IN_DIFF/1024/1024)*8/5.5), true);
    setState(Out_Speed, round((OUT_DIFF/1024/1024)*8/5.5), true);
}

on(HDD_Free, function(dp) {
   vHDD_Free = dp.state.val;
   setState(HDD_Used, (vHDD_Total - vHDD_Free), true);
});

on(Temperatur, function(dp) {
   vTemperatur = dp.state.val;
    var cTemp=vTemperatur*0.001;
    setState(CPU_Temperatur, Math.round(cTemp*100)/100, true);
});

on(TemperaturC0, function(dp) {
   vTemperaturC0 = dp.state.val;
    var cTemp=vTemperaturC0*0.001;
    setState(CPU_Temperatur_0, Math.round(cTemp*100)/100, true);
});

on(RAM_Frei, function(dp) {
    vRAM_Frei = dp.state.val;
    setState(RAM_Genutzt, vRAM_Total*1 - vRAM_Frei*1, true);
});

on(SWAP_Frei, function(dp) {
    vSWAP_Frei = dp.state.val;
    setState(SWAP_Genutzt, vSWAP_Total*1 - vSWAP_Frei*1, true);
});

schedule('*/5 * * * * *', function RPI4Net() {
   Netzwerk();
});
