const SteuerungAktiv = '0_userdata.0.Diverses.FensterSteuerungAktiv';

const FensterKZ             = 'deconz.0.Sensors.6.open';
const BalkontuerWZ          = 'deconz.0.Sensors.5.open';
const FensterWZ             = 'deconz.0.Sensors.25.open';
const FensterKueche         = 'deconz.0.Sensors.26.open';

const WZHeizungSommerModus  = 'fritzdect.0.DECT_099950189150.summeractive';
const KZHeizungSommerModus  = 'fritzdect.0.DECT_099950330172.summeractive';

const WZHeizungModeAuto     = 'fritzdect.0.DECT_099950189150.setmodeauto';
const WZHeizungModeOff      = 'fritzdect.0.DECT_099950189150.setmodeoff';

const KZHeizungModeAuto     = 'fritzdect.0.DECT_099950330172.setmodeauto';
const KZHeizungModeOff      = 'fritzdect.0.DECT_099950330172.setmodeoff';

createState(SteuerungAktiv, 1, {type: 'number', read: true, write: true}); //Für Einstellungsfenster

var WZSperre      = false;
var WZSperre2     = false;
var KuecheSperre  = false;
var KZSperre      = false;

function Aktiv() {
    return getState(SteuerungAktiv).val;
}

function SteuerungWZ(bFensterWZ=false,bBalkonWZ=false,Kueche=false) {
    if (bFensterWZ === false && bBalkonWZ === false && Kueche === false) {
        //geschlossen oder wieder zu
        setState(WZHeizungModeAuto,true);
    } else {
        //also die Tür oder (Fenster) ist immer noch offen - Heizung aus!
        setState(WZHeizungModeOff,true);
    }
}

on(BalkontuerWZ, function(dp) {
    if (WZSperre === false && Aktiv() == 1) {
        //nur wenn der Sommermodus nicht aktiv ist - also Heizmodus aktiv
        if (getState(WZHeizungSommerModus).val === false) {
            WZSperre = true;
            if (dp.state.val === true) {
                //offen
                setTimeout(function(){
                    //30 Sekunden warten, falls nur mal kurz aufgemacht um rauszusehen
                    SteuerungWZ(getState(FensterWZ).val,getState(BalkontuerWZ).val,getState(FensterKueche).val);
                    WZSperre = false;
                },30000);
            } else {
                SteuerungWZ(getState(FensterWZ).val,false,getState(FensterKueche).val);
                WZSperre = false;
            }
        }
    }
});

on(FensterWZ, function(dp) {
    if (WZSperre2 === false && Aktiv() == 1) {
        //nur wenn der Sommermodus nicht aktiv ist - also Heizmodus aktiv
        if (getState(WZHeizungSommerModus).val === false) {
            WZSperre2 = true;
            if (dp.state.val === true) {
                //offen
                setTimeout(function(){
                    //30 Sekunden warten, falls nur mal kurz aufgemacht um rauszusehen
                    SteuerungWZ(getState(FensterWZ).val,getState(BalkontuerWZ).val,getState(FensterKueche).val);
                    WZSperre2 = false;
                },30000);
            } else {
                SteuerungWZ(false,getState(BalkontuerWZ).val,getState(FensterKueche).val);
                WZSperre2 = false;
            }
        }
    }
});

on(FensterKueche, function(dp) {
    //Küchenfenster mit Wirkung Heizung Wohnzimmer
    if (KuecheSperre === false && Aktiv()==1) {
        //nur wenn der Sommermodus nicht aktiv ist - also Heizmodus aktiv
        if (getState(WZHeizungSommerModus).val === false) {
            KuecheSperre = true;
            if (dp.state.val === true) {
                //offen
                setTimeout(function(){
                    //5 Minuten warten, es dauert bis es im WZ auskühlt
                    SteuerungWZ(getState(FensterWZ).val,getState(BalkontuerWZ).val,getState(FensterKueche).val);
                    KuecheSperre = false;
                },300000);
            } else {
                SteuerungWZ(getState(FensterWZ).val,getState(BalkontuerWZ).val,false);
                KuecheSperre = false;
            }
        }
    }
});


on(FensterKZ, function(dp) {
    if (KZSperre === false && Aktiv()==1) {
        //nur wenn der Sommermodus nicht aktiv ist - also Heizmodus aktiv
        if (getState(KZHeizungSommerModus).val === false) {
            KZSperre = true;
            if (dp.state.val === false) {
                //geschlossen oder wieder zu
                setState(KZHeizungModeAuto,true);
                KZSperre = false;
            } else {
                //offen
                setTimeout(function(){
                    //20 Sekunden warten, falls nur mal kurz aufgemacht um rauszugehen
                    if (getState(FensterKZ).val === true) {
                        //also das Fenster ist immer noch offen - Heizung aus!
                        setState(KZHeizungModeOff,true);
                        KZSperre = false;
                    } else {
                        KZSperre = false;
                    }
                },20000);
            }
        }
    }
});

on(SteuerungAktiv, function(dp) {
    if (dp.state.val == 0) {
        //nur wenn deaktiviert, dann Heizungen auf Automodus schalten!
        if (getState(WZHeizungSommerModus).val === false) {
            setState(WZHeizungModeAuto,true);
        }
        if (getState(KZHeizungSommerModus).val === false) {
            setState(KZHeizungModeAuto,true);
        }
    }
});