'{"time":{"start":"00:01","exactTime":true},"period":{"days":1}}'// momentjs is required as dependecies in javascript adapter
const moment = require("moment");

var instances = $(`[id=ical.2.data.table]`);
instances.on(ical2CalendarWidget);

// remove this, if you know to use your own datapoint
let datapointId = '0_userdata.0.calendar.ical3calendar'
createState(datapointId, "[]", {
  read: true, 
  write: true, 
  desc: "JSON String for Calendar Widget", 
  type: "string", 
  def: "[]"
});

function ical2CalendarWidget() {
    try {
        let calList = [];

        for (var inst = 0; inst <= instances.length - 1; inst++) {
            let icalObj = getState(instances[inst]).val;

            if (icalObj) {
                for (var i = 0; i <= icalObj.length - 1; i++) {
                    let item = icalObj[i];

                    // extract calendar color
                    let calendarName = item._class.split(' ')[0].replace('ical_', '');

                    let startTime = moment(item._date);
                    let endTime = moment(item._end);
                    
                    let start = startTime.format("YYYY-MM-DD HH:mm");
                    let end = endTime.format("YYYY-MM-DD HH:mm");

                    if (startTime.format('HH:mm') === '00:00' && endTime.format('HH:mm') === '00:00') {
                        // is full-day event
                        if (endTime.diff(startTime, 'hours') === 24) {
                            // full-day event, one day
                            start = startTime.format("YYYY-MM-DD");
                            end = startTime.format("YYYY-MM-DD");
                        } else {
                            // full-day event, multiple days
                            start = startTime.format("YYYY-MM-DD");
                            end = endTime.format("YYYY-MM-DD");
                        }
                    }

                    var str=item.event;
                    var erg=false;
                    var farbe ="";
                    erg=str.includes('Gehalt');
                    if (erg===true) {
                        farbe = "#33B679";
                    }
                    erg=str.includes('Familienkasse');
                    if (erg===true) {
                        farbe = "#33B679";
                    }
                    erg=str.includes('Gewinn');
                    if (erg===true) {
                        farbe = "#33B679";
                    }
                    erg=str.includes('Kreditkarte');
                    if (erg===true) {
                        farbe = "#E67C73";
                    }
                    erg=str.includes('Wocheneinkauf');
                    if (erg===true) {
                        farbe = "#E67C73";
                    }
                    if (farbe==='') {
                        farbe = '#c15c5f';//item._calColor
                    }

                    var iSection='';
                    if(typeof item._section === 'undefined') {
                        iSection='';
                    } else {
                        iSection=item._section;
                    }
                    
                    // create object for calendar widget
                    calList.push({
                        start: start,
                        end: end,
                        name: item.event + " " + iSection,
                        color: farbe,
                        colorText: "#ffffff"
                    })
                }
            }

            // Enter the destination data point that is to be used as object ID in the widget                
            setState(datapointId, JSON.stringify(calList), true);
        }
    } catch (e) {
        console.error(`ical2MaterialDesignCalendarWidget: message: ${e.message}, stack: ${e.stack}`);
    }
}
ical2CalendarWidget();
