'{"time":{"start":"00:00","end":"24:00","mode":"minutes","interval":5},"period":{"days":1}}'// momentjs is required as dependecies in javascript adapter
const moment = require("moment");

var instances = $(`[id=ical.1.data.table]`);
instances.on(ical2CalendarWidget);

// remove this, if you know to use your own datapoint
let datapointId = '0_userdata.0.calendar.ical2calendar_stundenplan'
createState(datapointId, "[]", {
  read: true, 
  write: true, 
  desc: "JSON String for Calendar Widget", 
  type: "string", 
  def: "[]"
});

function ical2CalendarWidget() {
    try {
        let calList = [];

        for (var inst = 0; inst <= instances.length - 1; inst++) {
            let icalObj = getState(instances[inst]).val;

            if (icalObj) {
                for (var i = 0; i <= icalObj.length - 1; i++) {
                    let item = icalObj[i];

                    // extract calendar color
                    let calendarName = item._class.split(' ')[0].replace('ical_', '');

                    let startTime = moment(item._date);
                    let endTime = moment(item._end);
                    
                    let start = startTime.format("YYYY-MM-DD HH:mm");
                    let end = endTime.format("YYYY-MM-DD HH:mm");

                    if (startTime.format('HH:mm') === '00:00' && endTime.format('HH:mm') === '00:00') {
                        // is full-day event
                        if (endTime.diff(startTime, 'hours') === 24) {
                            // full-day event, one day
                            start = startTime.format("YYYY-MM-DD");
                            end = startTime.format("YYYY-MM-DD");
                        } else {
                            // full-day event, multiple days
                            start = startTime.format("YYYY-MM-DD");
                            end = endTime.format("YYYY-MM-DD");
                        }
                    }

                    var str=item.event;
                    var erg=false;
                    var farbe="";
                    var farbetext="";
                    erg=str.includes('. Ma');
                    if (erg===true) {
                        farbe = "#3F51B5";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. Bio');
                    if (erg===true) {
                        farbe = "#33B679";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. Eng');
                    if (erg===true) {
                        farbe = "#FFFFFF";
                        farbetext = "#000000";
                    }
                    erg=str.includes('. Eth');
                    if (erg===true) {
                        farbe = "#EFF74A";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. Sp');
                    if (erg===true) {
                        farbe = "#000000";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. D');
                    if (erg===true) {
                        farbe = "#D50000";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. Ku');
                    if (erg===true) {
                        farbe = "#1B4720";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. Frei');
                    if (erg===true) {
                        farbe = "#5E3D3D";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. Mu');
                    if (erg===true) {
                        farbe = "#F7734A";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('Einlass');
                    if (erg===true) {
                        farbe = "#EDADAD";
                        farbetext = "#000000";
                    }
                    erg=str.includes('. TC');
                    if (erg===true) {
                        farbe = "#A2A5B8";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. Meth');
                    if (erg===true) {
                        farbe = "#191636";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. Ge');
                    if (erg===true) {
                        farbe = "#B92DE3";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. KL');
                    if (erg===true) {
                        farbe = "#45ABB0";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('. Geo');
                    if (erg===true) {
                        farbe = "#F740EE";
                        farbetext = "#ffffff";
                    }
                    erg=str.includes('Bus');
                    if (erg===true) {
                        farbe = "#EDADAD";
                        farbetext = "#000000";
                    }
                    if (farbe==='') {
                        farbe = "#911300";
                        farbetext = "#ffffff";
                    }


                    // create object for calendar widget
                    calList.push({
                        start: start,
                        end: end,
                        name: item.event,
                        color: farbe,
                        // item._calColor,
                        colorText: farbetext
                    })
                }
            }

            // Enter the destination data point that is to be used as object ID in the widget                
            setState(datapointId, JSON.stringify(calList), true);
        }
    } catch (e) {
        console.error(`ical2MaterialDesignCalendarWidget: message: ${e.message}, stack: ${e.stack}`);
    }
}

ical2CalendarWidget();
