const idSumme = '0_userdata.0.Energy.SumKWh';
const idSummeOld = '0_userdata.0.Energy.SumKWh_Old';
const VerbrauchTag_Statistik = '0_userdata.0.Energy.SumKWh_Tag_Statistik';
const VerbrauchTag = '0_userdata.0.Energy.SumKWh_Tag';

createState(idSumme, 0, {type: 'number', unit: 'KWh', read: true, write: true});
createState(idSummeOld, 0, {type: 'number', unit: 'KWh', read: true, write: true});
createState(VerbrauchTag_Statistik, 0, {type: 'number', unit: 'KWh', read: true, write: true});
createState(VerbrauchTag, 0, {type: 'number', unit: 'KWh', read: true, write: true});
createState('0_userdata.0.Energy.StromLast7Days', "[]", {
  read: true, 
  write: true, 
  desc: "JSON String for Widget", 
  type: "string", 
  def: "[]"
});

function round(num) {
    var m = Number((Math.abs(num) * 100).toPrecision(15));
    return Math.round(m) / 100 * Math.sign(num);
}

function countSteckdosenVerbrauch(){
    var Energy = 0;

    var vData = getObject("enum.functions.energy_consumption").common.members;
    for(let i = 0; i < vData.length; i++) {
        var lValue = getState(vData[i]).val;
        Energy = Energy + lValue;
    }
    vData = null;
    lValue = null;
    
    Energy = round(Energy/1000);
    return Energy;
}

function summe() {
    var aValue = countSteckdosenVerbrauch();
    var oValue = getState(idSummeOld).val;
    setState(idSumme, aValue, true);
    setState(VerbrauchTag, aValue-oValue, true);
    
    setTimeout(function(){
        Diagramm7Tage();
    }, 5000);

    aValue = null;
    oValue = null;
}

function Diagramm7Tage() {
    var textA='';
    var myArrayA;
    sendTo('sql.0', 'query', 'SELECT id FROM iobroker.datapoints WHERE name="0_userdata.0.Energy.SumKWh_Tag_Statistik"', function (result) {
        if (result.error) {
            console.error(result.error);
        } else {
            var now = new Date();
            now.setHours(-168);
            sendTo('sql.0', 'query', 'SELECT from_unixtime(ts/1000) as ts FROM iobroker.ts_number WHERE ts >= ' + now.getTime() + ' AND id=' + result.result[0].id, function (resultA) {
                textA = JSON.stringify(resultA.result);
            });
        }
    });

    var Master='';
    sendTo('sql.0', 'query', 'SELECT id FROM iobroker.datapoints WHERE name="0_userdata.0.Energy.SumKWh_Tag_Statistik"', function (result) {
        if (result.error) {
            console.error(result.error);
        } else {
            var now = new Date();
            now.setHours(-168);
            sendTo('sql.0', 'query', 'SELECT val FROM iobroker.ts_number WHERE ts >= ' + now.getTime() + ' AND id=' + result.result[0].id, function (result) {
                let text = JSON.stringify(result.result);
                myArrayA = textA.split(",");
                const myArray = text.split(",");
                if (myArray.length == myArrayA.length) {
                    for (let i = 0; i <= 6; i++) {
                        var vARow=myArrayA[i].replace('"ts":','').replace('{','').replace('}','').replace('[','').replace(']','');
                        var vRow=myArray[i].replace('"val":','').replace('{','').replace('}','').replace('[','').replace(']','');
                        if (i < 1 ) {
                            Master='[{"label": "'+vARow.slice(9,11)+'.'+vARow.slice(6,8)+'.'+'","value": "'+vRow+'","dataColor": "#9c2121","valueColor": " #ffffff"}';
                        } else {
                            Master=Master+', {"label": "'+vARow.slice(9,11)+'.'+vARow.slice(6,8)+'.'+'","value": "'+vRow+'","dataColor": "#9c2121","valueColor": " #ffffff"}';
                        }
                    }
                    Master=Master+', {"label": "heute","value": "'+getState('0_userdata.0.Energy.SumKWh_Tag').val+'","dataColor": "#61805e","valueColor": " #ffffff"}';
                    Master=Master+']';
                    setState('0_userdata.0.Energy.StromLast7Days', Master, true);
                }
            });
        }
    });
    Master = null;
    myArrayA = null;
}

$('state(functions=energy_consumption)').on(function(obj) {
    summe();
});

schedule('59 23 * * *', function TagesWert() {
    var oValue = getState(idSummeOld).val;
    var aValue = countSteckdosenVerbrauch();
    setState(VerbrauchTag_Statistik, aValue-oValue, true);
    setState(idSummeOld, aValue, true);

    oValue = null;
    aValue = null;
});

summe();