createState('0_userdata.0.Energy.Stromberechnung.BeginnTag', '01', {type: 'string', read: true, write: true});
createState('0_userdata.0.Energy.Stromberechnung.BeginnMonat', '06', {type: 'string', read: true, write: true});
createState('0_userdata.0.Energy.Stromberechnung.Grundpreis', 101.75, {type: 'number', unit: 'EUR', read: true, write: true});
createState('0_userdata.0.Energy.Stromberechnung.PreisKWh', 29.6, {type: 'number', unit: 'Cent', read: true, write: true});
createState('0_userdata.0.Energy.Stromberechnung.Zusatzverbrauch', 700, {type: 'number', unit: 'kWh', read: true, write: true});
createState('0_userdata.0.Energy.Stromberechnung.Abschlag', 84, {type: 'number', unit: 'EUR', read: true, write: true});
createState('0_userdata.0.Energy.Stromberechnung.Vorjahr', 0, {type: 'number', unit: 'kWh', read: true, write: true});

const mW1 = '0_userdata.0.Energy.SumKWh';

const SumTag = '0_userdata.0.Energy.SumTag';
const SumJahr = '0_userdata.0.Energy.SumJahr';
const SumJahrGesamt = '0_userdata.0.Energy.SumJahrGesamt';
const PreisTag = '0_userdata.0.Energy.PreisTag';
const PreisJahr = '0_userdata.0.Energy.PreisJahr';
const PreisGesamt = '0_userdata.0.Energy.PreisGesamt';
const PreisMonat = '0_userdata.0.Energy.PreisMonat';
const PreisZusatz = '0_userdata.0.Energy.PreisZusatz';
const PreisZusatz12 = '0_userdata.0.Energy.PreisZusatz12';
const SumDiffAbschlag = '0_userdata.0.Energy.SumDiffAbschlag';
const TextDiffAbschlag = '0_userdata.0.Energy.TextDiffAbschlag';
const lRechnung = '0_userdata.0.Energy.lRechnung';
const lRechnungVorzeichen = '0_userdata.0.Energy.lRechnungVorzeichen';

createState(SumTag, 0, {type: 'number', unit: 'KWh', read: true, write: true});
createState(SumJahr, 0, {type: 'number', unit: 'KWh', read: true, write: true});
createState(SumJahrGesamt, 0, {type: 'number', unit: 'KWh', read: true, write: true});
createState(PreisTag, 0, {type: 'number', unit: 'EUR', read: true, write: true});
createState(PreisJahr, 0, {type: 'number', unit: 'EUR', read: true, write: true});
createState(PreisGesamt, 0, {type: 'number', unit: 'EUR', read: true, write: true});
createState(PreisMonat, 0, {type: 'number', unit: 'EUR', read: true, write: true});
createState(PreisZusatz, 0, {type: 'number', unit: 'EUR', read: true, write: true});
createState(PreisZusatz12, 0, {type: 'number', unit: 'EUR', read: true, write: true});
createState(SumDiffAbschlag, 0, {type: 'number', unit: 'EUR', read: true, write: true});
createState(TextDiffAbschlag, 0, {type: 'string', unit: '', read: true, write: true});
createState(lRechnung, 0, {type: 'number', unit: 'EUR', read: true, write: true});
createState(lRechnungVorzeichen, 0, {type: 'string', read: true, write: true});


function difference(date1, date2) {  
    const date1utc = Date.UTC(date1.getFullYear(), date1.getMonth(), date1.getDate());
    const date2utc = Date.UTC(date2.getFullYear(), date2.getMonth(), date2.getDate());
    //day = 1000*60*60*24;
  return(date2utc - date1utc) / 86400000 //day
}

function round(num) {
    var m = Number((Math.abs(num) * 100).toPrecision(15));
    return Math.round(m) / 100 * Math.sign(num);
}

function summe() {
    const d = new Date();

    let jahr = d.getFullYear();
    let monat = d.getMonth();
    let tag = d.getDate();

    const dBeginn = getState('0_userdata.0.Energy.Stromberechnung.BeginnTag').val;
    const mBeginn = getState('0_userdata.0.Energy.Stromberechnung.BeginnMonat').val;
    const cGrundpreis = getState('0_userdata.0.Energy.Stromberechnung.Grundpreis').val;
    const cVPreis = getState('0_userdata.0.Energy.Stromberechnung.PreisKWh').val;
    const PlusVerbrauch = getState('0_userdata.0.Energy.Stromberechnung.Zusatzverbrauch').val;
    const cAbschlag = getState('0_userdata.0.Energy.Stromberechnung.Abschlag').val;

    var Startdatum = new Date(jahr + "-" + mBeginn + "-" + dBeginn);
    var Currentdatum = new Date(jahr + "-" + (monat+1) + "-" + tag);

    if (Currentdatum > Startdatum) {
        //Beginn liegt in der Vergangenheit, gleiches Jahr verwenden
        var StartNeudatum = new Date(jahr + "-" + mBeginn + "-" + dBeginn);
    } else {
        //Beginn liegt in der Zukunft, Jahr-1 verwenden
        var StartNeudatum = new Date((jahr-1) + "-" + mBeginn + "-" + dBeginn);
    }

    var TageVergangen = difference(StartNeudatum,Currentdatum)+1;
    var wW1 = getState(mW1).val;
    var kwhTag = wW1/TageVergangen;

    setState(SumTag, round(kwhTag), true);
    setState(SumJahr, round(kwhTag*365), true);
    setState(SumJahrGesamt, round(kwhTag*365)+getState('0_userdata.0.Energy.Stromberechnung.Zusatzverbrauch').val, true);
    setState(PreisTag, round(kwhTag*(cVPreis/100)), true);
    setState(PreisJahr, round(kwhTag*365*(cVPreis/100)), true);
    setState(PreisGesamt, round((kwhTag*365*(cVPreis/100)))+cGrundpreis, true);
    setState(PreisMonat, round(((kwhTag*365*(cVPreis/100))+cGrundpreis)/12), true);
    setState(PreisZusatz, PlusVerbrauch*(cVPreis/100), true);
    setState(PreisZusatz12, round((PlusVerbrauch*(cVPreis/100))/12), true);

    var vAbschlag = (cAbschlag*12) - ((((kwhTag*365)+PlusVerbrauch)*(cVPreis/100))+cGrundpreis);
    setState(lRechnung, round(Math.abs(vAbschlag-cAbschlag)), true);

    if (vAbschlag < 0) {
        setState(TextDiffAbschlag, "Nachzahlung ca.:", true);
        setState(SumDiffAbschlag, round(Math.abs(vAbschlag)), true);
        setState(lRechnungVorzeichen, "-", true);
    } else {
        setState(TextDiffAbschlag, "Guthaben ca.:", true);
        setState(SumDiffAbschlag, round(Math.abs(vAbschlag)), true);
        setState(lRechnungVorzeichen, "+", true);
    }
}

summe();

schedule('*/5 * * * *', function Aktualisierung() {
    summe();
});
