createState('0_userdata.0.Wetter.Ozon', 0, {type: 'number', read: true, write: true});
createState('0_userdata.0.Wetter.OzonInfo', '', {type: 'string', read: true, write: true});
createState('0_userdata.0.Wetter.OzonFarbCode', '', {type: 'string', read: true, write: true});

createState('0_userdata.0.Wetter.PM10', 0, {type: 'number', read: true, write: true});
createState('0_userdata.0.Wetter.PM10Info', '', {type: 'string', read: true, write: true});
createState('0_userdata.0.Wetter.PM10FarbCode', '', {type: 'string', read: true, write: true});

createState('0_userdata.0.Wetter.NO2', 0, {type: 'number', read: true, write: true});
createState('0_userdata.0.Wetter.NO2Info', '', {type: 'string', read: true, write: true});
createState('0_userdata.0.Wetter.NO2FarbCode', '', {type: 'string', read: true, write: true});

createState('0_userdata.0.Wetter.Strahlung', 0, {type: 'string', unit: 'µSv/h', read: true, write: true});
createState('0_userdata.0.Wetter.StrahlungJahr', 0, {type: 'string', unit: 'mSv/a', read: true, write: true});
createState('0_userdata.0.Wetter.StrahlungFarbCode', '', {type: 'string', read: true, write: true});

LuftMessDaten();
StrahlungsDaten();

function StrahlungsDaten() {
    var request = require('request');
    //https://www.imis.bfs.de/ogc/opendata/ows?service=WFS&version=1.1.0&request=GetFeature&typeName=opendata:odlinfo_odl_1h_latest&outputFormat=application/json
    //hier kann die Kennzahl für den Ort gefunden werden

    var options = {url: 'https://www.imis.bfs.de/ogc/opendata/ows?service=WFS&version=1.1.0&request=GetFeature&typeName=opendata:odlinfo_timeseries_odl_1h&outputFormat=application/json&viewparams=kenn:142720101#&sortBy=end_measure+A&maxFeatures=168', method: 'GET', headers: { 'User-Agent': 'request' }};
    request(options, function(error, response, body) {
        if (!error && response.statusCode == 200) {
            var info = body;
            var Position = info.indexOf("],");
            var info = info.substr(Position-85, 100);
            var Position = info.indexOf(":");
            var info = info.substr(Position+1, 15);
            var pos=info.indexOf(",");
            var str=info;
            str = str.substr(0, pos);
            setState('0_userdata.0.Wetter.Strahlung', str);
            var swert = ((str*24*365)/1000).toFixed(3);
            setState('0_userdata.0.Wetter.StrahlungJahr', swert);
            if (swert <= 1) {
                setState('0_userdata.0.Wetter.StrahlungFarbCode', '#00ff00');
            } else if (swert <= 2) {    
                setState('0_userdata.0.Wetter.StrahlungFarbCode', '#ffff00');
            } else if (swert <= 3) {    
                setState('0_userdata.0.Wetter.StrahlungFarbCode', '#ff9900');
            } else {
                setState('0_userdata.0.Wetter.StrahlungFarbCode', '#ff0000');
            }
        }    
    })
}

function LuftMessDaten() {
    var request = require('request');
    var options = {url: 'https://luft.jetzt/DESN004', method: 'GET', headers: { 'User-Agent': 'request' }};

    request(options, function(error, response, body) {
        if (!error && response.statusCode == 200) {
            var info = body;
            var Position = info.indexOf("h-100 o3");
            var dummy = info.substr(Position, 300);
            var Position = dummy.indexOf("µg");
            var wert = parseInt(dummy.substr(Position-7, 6));
            setState('0_userdata.0.Wetter.Ozon', wert);
            if (wert >= 240) {
                setState('0_userdata.0.Wetter.OzonInfo', 'sehr schlecht');
                setState('0_userdata.0.Wetter.OzonFarbCode', '#ff0000');
            } else if (wert >= 180) {
                setState('0_userdata.0.Wetter.OzonInfo', 'schlecht');
                setState('0_userdata.0.Wetter.OzonFarbCode', '#ff9900');
            } else if (wert >= 120) {
                setState('0_userdata.0.Wetter.OzonInfo', 'unbefriedigend');
                setState('0_userdata.0.Wetter.OzonFarbCode', '#ffff00');
            } else if (wert >= 65) {
                setState('0_userdata.0.Wetter.OzonInfo', 'befriedigend');
                setState('0_userdata.0.Wetter.OzonFarbCode', '#ffff00');
            } else if (wert >= 33) {
                setState('0_userdata.0.Wetter.OzonInfo', 'gut');
                setState('0_userdata.0.Wetter.OzonFarbCode', '#00ff00');
            } else if (wert >= 0) {
                setState('0_userdata.0.Wetter.OzonInfo', 'sehr gut');
                setState('0_userdata.0.Wetter.OzonFarbCode', '#00ff00');
            }

            var Position = info.indexOf("h-100 pm10");
            var dummy = info.substr(Position, 300);
            var Position = dummy.indexOf("µg");
            var wert = parseInt(dummy.substr(Position-7, 6));
            setState('0_userdata.0.Wetter.PM10', wert);
            if (wert >= 100) {
                setState('0_userdata.0.Wetter.PM10Info', 'sehr schlecht');
                setState('0_userdata.0.Wetter.PM10FarbCode', '#ff0000');
            } else if (wert >= 50) {
                setState('0_userdata.0.Wetter.PM10Info', 'schlecht');
                setState('0_userdata.0.Wetter.PM10FarbCode', '#ff9900');
            } else if (wert >= 35) {
                setState('0_userdata.0.Wetter.PM10Info', 'unbefriedigend');
                setState('0_userdata.0.Wetter.PM10FarbCode', '#ffff00');
            } else if (wert >= 20) {
                setState('0_userdata.0.Wetter.PM10Info', 'befriedigend');
                setState('0_userdata.0.Wetter.PM10FarbCode', '#ffff00');
            } else if (wert >= 10) {
                setState('0_userdata.0.Wetter.PM10Info', 'gut');
                setState('0_userdata.0.Wetter.PM10FarbCode', '#00ff00');
            } else if (wert >= 0) {
                setState('0_userdata.0.Wetter.PM10Info', 'sehr gut');
                setState('0_userdata.0.Wetter.PM10FarbCode', '#00ff00');
            }

            var Position = info.indexOf("h-100 no2");
            var dummy = info.substr(Position, 300);
            var Position = dummy.indexOf("µg");
            var wert = parseInt(dummy.substr(Position-7, 6));
            setState('0_userdata.0.Wetter.NO2', wert);
            if (wert >= 500) {
                setState('0_userdata.0.Wetter.NO2Info', 'sehr schlecht');
                setState('0_userdata.0.Wetter.NO2FarbCode', '#ff0000');
            } else if (wert >= 200) {
                setState('0_userdata.0.Wetter.NO2Info', 'schlecht');
                setState('0_userdata.0.Wetter.NO2FarbCode', '#ff9900');
            } else if (wert >= 100) {
                setState('0_userdata.0.Wetter.NO2Info', 'unbefriedigend');
                setState('0_userdata.0.Wetter.NO2FarbCode', '#ffff00');
            } else if (wert >= 50) {
                setState('0_userdata.0.Wetter.NO2Info', 'befriedigend');
                setState('0_userdata.0.Wetter.NO2FarbCode', '#ffff00');
            } else if (wert >= 25) {
                setState('0_userdata.0.Wetter.NO2Info', 'gut');
                setState('0_userdata.0.Wetter.NO2FarbCode', '#00ff00');
            } else if (wert >= 0) {
                setState('0_userdata.0.Wetter.NO2Info', 'sehr gut');
                setState('0_userdata.0.Wetter.NO2FarbCode', '#00ff00');
            }

        }    
    })
}

schedule('*/30 * * * *', function LadeLuftdaten() {
    LuftMessDaten();
    StrahlungsDaten();
});
